<?php
/**
 * Fashion Outfit functions and definitions
 *
 * @package Fashion Outfit
 */

if ( ! defined( 'fashion_outfit_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'fashion_outfit_VERSION', '1.0.0' );
}

function fashion_outfit_setup() {

	load_theme_textdomain( 'fashion-outfit', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'fashion-outfit' ),
			'social-menu' => esc_html__('Social Menu', 'fashion-outfit'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'fashion_outfit_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'fashion_outfit_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $fashion_outfit_content_width
 */
function fashion_outfit_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'fashion_outfit_content_width', 640 );
}
add_action( 'after_setup_theme', 'fashion_outfit_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function fashion_outfit_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'fashion-outfit' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'fashion-outfit' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'fashion-outfit' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'fashion-outfit' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'fashion-outfit' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'fashion-outfit' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'fashion-outfit' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'fashion-outfit' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'fashion_outfit_widgets_init' );


function fashion_outfit_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }


function fashion_outfit_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => 'Poppins:wght@100;200;300;400;500;600;700;800;900|Pacifico',
        'display' => 'swap',
    );
    wp_enqueue_style('fashion-outfit-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Owl Carousel CSS
    wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), '2.3.4');
    
    // Main stylesheet
    wp_enqueue_style('fashion-outfit-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

	// Add custom inline styles
	require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('fashion-outfit-style', $fashion_outfit_custom_css);

    // RTL styles if needed
    wp_style_add_data('fashion-outfit-style', 'rtl', 'replace');

    // Navigation script
    wp_enqueue_script('fashion-outfit-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), '2.3.4', true);

    // Custom script
    wp_enqueue_script('fashion-outfit-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'fashion_outfit_scripts');


if (!function_exists('fashion_outfit_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function fashion_outfit_related_post($post_id){        
        $fashion_outfit_categories = get_the_category($post_id);
        if ($fashion_outfit_categories) {
            $fashion_outfit_category_ids = array();
            $fashion_outfit_category = get_category($fashion_outfit_category_ids);
            $fashion_outfit_categories = get_the_category($post_id);
            foreach ($fashion_outfit_categories as $fashion_outfit_category) {
                $fashion_outfit_category_ids[] = $fashion_outfit_category->term_id;
            }
            $fashion_outfit_count = $fashion_outfit_category->category_count;
            if ($fashion_outfit_count > 1) { ?>

         	<?php
		$fashion_outfit_related_post_wrap = absint(get_theme_mod('fashion_outfit_enable_related_post', 1));
		if($fashion_outfit_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('fashion_outfit_related_post_text', __('Related Post', 'fashion-outfit'))); ?></h2>
                    <?php
                    $fashion_outfit_cat_post_args = array(
                        'category__in' => $fashion_outfit_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'fashion_outfit_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $fashion_outfit_featured_query = new WP_Query($fashion_outfit_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($fashion_outfit_featured_query->have_posts()) :

                        while ($fashion_outfit_featured_query->have_posts()) : $fashion_outfit_featured_query->the_post();
                            ?>

							<div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php fashion_outfit_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $fashion_outfit_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/Elegant-Evening-Gowns.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $fashion_outfit_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        fashion_outfit_posted_on();
                                        fashion_outfit_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('fashion_outfit_related_posts', 'fashion_outfit_related_post', 10, 1);

function fashion_outfit_sanitize_choices( $fashion_outfit_input, $fashion_outfit_setting ) {
    global $wp_customize; 
    $fashion_outfit_control = $wp_customize->get_control( $fashion_outfit_setting->id ); 
    if ( array_key_exists( $fashion_outfit_input, $fashion_outfit_control->choices ) ) {
        return $fashion_outfit_input;
    } else {
        return $fashion_outfit_setting->default;
    }
}

//Excerpt 
function fashion_outfit_excerpt_function($fashion_outfit_excerpt_count = 35) {
    $fashion_outfit_excerpt = get_the_excerpt();
    $fashion_outfit_text_excerpt = wp_strip_all_tags($fashion_outfit_excerpt);
    $fashion_outfit_excerpt_limit = (int) get_theme_mod('fashion_outfit_excerpt_limit', $fashion_outfit_excerpt_count);
    $fashion_outfit_words = preg_split('/\s+/', $fashion_outfit_text_excerpt); 
    $fashion_outfit_trimmed_words = array_slice($fashion_outfit_words, 0, $fashion_outfit_excerpt_limit);
    $fashion_outfit_theme_excerpt = implode(' ', $fashion_outfit_trimmed_words);

    return $fashion_outfit_theme_excerpt;
}

// Add admin notice
function fashion_outfit_admin_notice() { 
    global $pagenow;
    $fashion_outfit_theme_args      = wp_get_theme();
    $fashion_outfit_meta            = get_option( 'fashion_outfit_admin_notice' );
    $name            = $fashion_outfit_theme_args->__get( 'Name' );
    $fashion_outfit_current_screen  = get_current_screen();

    if( !$fashion_outfit_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $fashion_outfit_current_screen->base !== 'appearance_page_fashion_outfit_guide' && 
            $fashion_outfit_current_screen->base !== 'toplevel_page_fashionoutfit-demoimport' ) { ?>

            <div class="notice notice-success fashion-outfit-welcome-notice">
                <p class="fashion-outfit-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'fashion_outfit_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'fashion-outfit' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="fashion-outfit-welcome-notice-wrap">
                    <h2 class="fashion-outfit-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $fashion_outfit_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'fashion-outfit' ), $fashion_outfit_theme_name ) );
                        ?>
                    </h2>
                    <p class="fashion-outfit-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'fashion-outfit' ); ?>
                    </p>

                    <div class="fashion-outfit-welcome-info">
                        <div class="fashion-outfit-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'fashion-outfit' ); ?>">
                        </div>

                        <div class="fashion-outfit-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'fashion-outfit' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'fashion-outfit' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=fashionoutfit-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'fashion-outfit' ); ?></a></p>
                        </div>

                        <div class="fashion-outfit-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'fashion-outfit' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'fashion-outfit' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=fashion-outfit-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'fashion-outfit' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }
	}
}

add_action( 'admin_notices', 'fashion_outfit_admin_notice' );

if( ! function_exists( 'fashion_outfit_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function fashion_outfit_update_admin_notice(){
    if ( isset( $_GET['fashion_outfit_admin_notice'] ) && $_GET['fashion_outfit_admin_notice'] = '1' ) {
        update_option( 'fashion_outfit_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'fashion_outfit_update_admin_notice' );


add_action('after_switch_theme', 'fashion_outfit_setup_options');
function fashion_outfit_setup_options () {
    update_option('fashion_outfit_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$fashion_outfit_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function fashion_outfit_sanitize_checkbox($fashion_outfit_checked)
{
    // Boolean check.
    return ((isset($fashion_outfit_checked) && true == $fashion_outfit_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';


/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function fashion_outfit_enqueue_function() {

    /**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/fashion_outfit_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/fashion_outfit_config_file.php';

	define('FASHION_OUTFIT_FREE_SUPPORT',__('https://wordpress.org/support/theme/fashion-outfit/','fashion-outfit'));
	define('FASHION_OUTFIT_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','fashion-outfit'));
	define('FASHION_OUTFIT_REVIEW',__('https://wordpress.org/support/theme/fashion-outfit/reviews/#new-post','fashion-outfit'));
	define('FASHION_OUTFIT_BUY_NOW',__('https://www.revolutionwp.com/products/fashion-outfit-wordpress-theme','fashion-outfit'));
	define('FASHION_OUTFIT_LIVE_DEMO',__('https://demo.revolutionwp.com/fashion-outfits-pro/','fashion-outfit'));
	define('FASHION_OUTFIT_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/fashion-outfits-pro/','fashion-outfit'));
	define('FASHION_OUTFIT_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/fashion-outfits-free/','fashion-outfit'));

}
add_action( 'after_setup_theme', 'fashion_outfit_enqueue_function' );

function fashion_outfit_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'fashion_outfit_remove_customize_register', 11 );

/************************************************************************************/
// //////////////////////////////////////////////

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'fashion_outfit_loop_columns');

if (!function_exists('fashion_outfit_loop_columns')) {

	function fashion_outfit_loop_columns() {

		$fashion_outfit_columns = get_theme_mod( 'fashion_outfit_per_columns', 3 );

		return $fashion_outfit_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'fashion_outfit_per_page', 20 );

function fashion_outfit_per_page( $fashion_outfit_cols ) {

  	$fashion_outfit_cols = get_theme_mod( 'fashion_outfit_product_per_page', 9 );

	return $fashion_outfit_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'fashion_outfit_products_args' );

function fashion_outfit_products_args( $fashion_outfit_args ) {

    $fashion_outfit_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $fashion_outfit_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $fashion_outfit_args;
}

/************************************************************************************/


/**
 * Custom logo
 */

function fashion_outfit_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --fashion_outfit_logo_width: <?php echo absint(get_theme_mod('fashion_outfit_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('fashion_outfit_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'fashion_outfit_custom_css' );

function get_changelog_from_readme() {
	$fashion_outfit_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

	if (file_exists($fashion_outfit_file_path)) {
		$fashion_outfit_content = file_get_contents($fashion_outfit_file_path);

		// Extract changelog section
		$fashion_outfit_changelog_start = strpos($fashion_outfit_content, "== Changelog ==");
		$fashion_outfit_changelog = substr($fashion_outfit_content, $fashion_outfit_changelog_start);

		// Split changelog into versions
		preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $fashion_outfit_changelog, $fashion_outfit_matches, PREG_SET_ORDER);
		
		return $fashion_outfit_matches;
	}
	return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );